//+------------------------------------------------------------------+
//|                                                     xCandles.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
 
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red //B
#property indicator_color2 Blue  //BHG
#property indicator_color3 DarkOrchid //LS

//extern string CornerSubida = "0:topleft, 1:top-right, 2:bottom-left, 3:bottom-right";
extern bool limitarBarras	= true;
extern int  limite			= 1000;
extern bool alertsON		= false;
extern bool showB			= true;
extern bool showBHG			= true;
extern bool showLS			= true;
extern bool showGaps		= false;
extern double gapSizePips	= 20.0;
//extern bool showSpikes		= true;


int n_digits = 0;

int flagval1 = 0, flagval2 = 0;
int flagval3 = 0, flagval4 = 0;
int flagval5 = 0, flagval6 = 0;
int flagval7 = 0, flagval8 = 0;

double B[], BHG[];
double LS[], serieDown_2[];
double serieUp_3[], serieDown_3[];
double serieUp_4[], serieDown_4[];

double mediaATRAnt = 0, mediaVolAnt = 0; //int ExtCountedBarsATR=0, ExtCountedBarsVol=0;

bool SoundON = true;
datetime prevtime; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	SetIndexStyle(0, DRAW_ARROW, EMPTY, 1); //B
	SetIndexArrow(0, 158);
	SetIndexBuffer(0, B);
	
	SetIndexStyle(1, DRAW_ARROW, EMPTY, 1); //B HG
	SetIndexArrow(1, 159);
	SetIndexBuffer(1, BHG);
	
	SetIndexStyle(2, DRAW_ARROW, EMPTY, 1); //LS
	SetIndexArrow(2, 115);
	SetIndexBuffer(2, LS);

	GlobalVariableSet("AlertTime_1"+Symbol()+Period(),TimeCurrent());
	GlobalVariableSet("SignalType_1"+Symbol()+Period(),OP_SELLSTOP);
	
	GlobalVariableSet("AlertTime_2"+Symbol()+Period(),TimeCurrent());
	GlobalVariableSet("SignalType_2"+Symbol()+Period(),OP_SELLSTOP);
	
	GlobalVariableSet("AlertTime_3"+Symbol()+Period(),TimeCurrent());
	GlobalVariableSet("SignalType_3"+Symbol()+Period(),OP_SELLSTOP);
	
	GlobalVariableSet("AlertTime_4"+Symbol()+Period(),TimeCurrent());
	GlobalVariableSet("SignalType_4"+Symbol()+Period(),OP_SELLSTOP);
	
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   GlobalVariableDel("AlertTime_1"+Symbol()+Period());
   GlobalVariableDel("SignalType_1"+Symbol()+Period());
   GlobalVariableDel("AlertTime_2"+Symbol()+Period());
   GlobalVariableDel("SignalType_2"+Symbol()+Period());
   GlobalVariableDel("AlertTime_3"+Symbol()+Period());
   GlobalVariableDel("SignalType_3"+Symbol()+Period());
   GlobalVariableDel("AlertTime_4"+Symbol()+Period());
   GlobalVariableDel("SignalType_4"+Symbol()+Period());
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
	static datetime Time0; if (Time0 == Time[0]) return(0); Time0 = Time[0]; //Solo continua al comienzo de una barra nueva
	
	datetime tiempoInicio = TimeCurrent();
	RefreshRates();
	WindowRedraw();
	int timeFrame = Period(); string par = Symbol();
   	int limit, i, counter;
   	double tmp=0;
   	int MA_Mode = 1, PriceMode = 0;
   	double Range, AvgRange;
   	int counted_bars=IndicatorCounted();
   	if(counted_bars<0) return(-1);
   	if(counted_bars>0) counted_bars--;
   
	if(limitarBarras) counted_bars = Bars-limite;
 
   	limit=Bars-counted_bars;


   	for(i = limit; i >= 0; i--) {
      	counter=i;
      	Range=0;
      	AvgRange=0;
      	for (counter=i ;counter<=i+9;counter++) AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      	Range=AvgRange/10;
		
		int velaLeida = i+1;
		
		if(showB)
		{  
	      	if(B_Bars(false, 5, i) && !B_Bars(true, 5, i))
	      	{
	         	if (i == 1 && flagval1==0){  flagval1=1; flagval2=0; }
	         	B[i+2] = puntoMedio( (i+2) );
	         	if(alertsON && i==0) Alert(Symbol() + " " + TFToStr(Period()) + ": B");
	      	}
	    }  	
	    if(showBHG)
	    {
	    	if(B_Bars(true, 5, i))
	      	{
	         	if (i == 1 && flagval1==0){  flagval1=1; flagval2=0; }
	         	BHG[i+2] = puntoMedio( (i+2) );
	         	if(alertsON && i==0) Alert(Symbol() + " " + TFToStr(Period()) + ": BHG");
	      	}
		}
		
		if(showLS)
		{
			if(detectorSpikes("LS_DOWN", velaLeida))
	      	{
	         	if (i == 1 && flagval1==0){  flagval1=1; flagval2=0; }
	         	LS[velaLeida] = High[velaLeida] + Range*0.4;
	         	if(alertsON && i==0) Alert(Symbol() + " " + TFToStr(Period()) + ": LS_UP");
	      	}
	      	else if(detectorSpikes("LS_UP", velaLeida))
	      	{
	         	if (i == 1 && flagval2==0) { flagval2=1; flagval1=0; }
	         	LS[velaLeida] = Low[velaLeida] - Range*0.4;
	         	if(alertsON && i==0) Alert(Symbol() + " " + TFToStr(Period()) + ": LS_DOWN");
	      	}
		}
		
	    
     	if(showGaps)
     	{ 	
     		int nVelas = 0;
			if(gapDetector(nVelas, Symbol(), gapSizePips, Period(), velaLeida) == 0)
	      	{
	         	Alert(Symbol() + " " + TFToStr(Period()) + ": GAP de subida");
	      	}
	      	else if(gapDetector(nVelas, Symbol(), gapSizePips, Period(), velaLeida) == 1)
	      	{
	         	Alert(Symbol() + " " + TFToStr(Period()) + ": GAP de bajada");
	      	}
	    }
   	}
   
	//Grupo 1
   	if (flagval1==1 && TimeCurrent() > GlobalVariableGet("AlertTime_1"+Symbol()+Period()) && GlobalVariableGet("SignalType_1"+Symbol()+Period())!=OP_BUY)
   	{
      	//if (SoundON) Alert(Symbol());
      	tmp = TimeCurrent() + (Period()-MathMod(Minute(),Period()))*60;
      	GlobalVariableSet("AlertTime_1"+Symbol()+Period(),tmp);
      	GlobalVariableSet("SignalType_1"+Symbol()+Period(),OP_BUY);
   	}
   
   	if (flagval2==1 && TimeCurrent() > GlobalVariableGet("AlertTime_1"+Symbol()+Period()) && GlobalVariableGet("SignalType_1"+Symbol()+Period())!=OP_SELL) 
   	{
      	//if (SoundON) Alert(Symbol());
      	tmp = TimeCurrent() + (Period()-MathMod(Minute(),Period()))*60;
      	GlobalVariableSet("AlertTime_1"+Symbol()+Period(),tmp);
      	GlobalVariableSet("SignalType_1"+Symbol()+Period(),OP_SELL);
   	}
   	
   	//Grupo 2
   	if (flagval3==1 && TimeCurrent() > GlobalVariableGet("AlertTime_2"+Symbol()+Period()) && GlobalVariableGet("SignalType_2"+Symbol()+Period())!=OP_BUY)
   	{
      	//if (SoundON) Alert(Symbol());
      	tmp = TimeCurrent() + (Period()-MathMod(Minute(),Period()))*60;
      	GlobalVariableSet("AlertTime_2"+Symbol()+Period(),tmp);
      	GlobalVariableSet("SignalType_2"+Symbol()+Period(),OP_BUY);
   	}
   
   	if (flagval4==1 && TimeCurrent() > GlobalVariableGet("AlertTime_2"+Symbol()+Period()) && GlobalVariableGet("SignalType_2"+Symbol()+Period())!=OP_SELL) 
   	{
      	//if (SoundON) Alert(Symbol());
      	tmp = TimeCurrent() + (Period()-MathMod(Minute(),Period()))*60;
      	GlobalVariableSet("AlertTime_2"+Symbol()+Period(),tmp);
      	GlobalVariableSet("SignalType_2"+Symbol()+Period(),OP_SELL);
   	}
   	
   	//Grupo 3
   	if (flagval5==1 && TimeCurrent() > GlobalVariableGet("AlertTime_3"+Symbol()+Period()) && GlobalVariableGet("SignalType_3"+Symbol()+Period())!=OP_BUY)
   	{
      	//if (SoundON) Alert(Symbol());
      	tmp = TimeCurrent() + (Period()-MathMod(Minute(),Period()))*60;
      	GlobalVariableSet("AlertTime_3"+Symbol()+Period(),tmp);
      	GlobalVariableSet("SignalType_3"+Symbol()+Period(),OP_BUY);
   	}
   
   	if (flagval6==1 && TimeCurrent() > GlobalVariableGet("AlertTime_3"+Symbol()+Period()) && GlobalVariableGet("SignalType_3"+Symbol()+Period())!=OP_SELL) 
   	{
      	//if (SoundON) Alert(Symbol());
      	tmp = TimeCurrent() + (Period()-MathMod(Minute(),Period()))*60;
      	GlobalVariableSet("AlertTime_3"+Symbol()+Period(),tmp);
      	GlobalVariableSet("SignalType_3"+Symbol()+Period(),OP_SELL);
   	}
   	
   	//Grupo 4
   	if (flagval7==1 && TimeCurrent() > GlobalVariableGet("AlertTime_4"+Symbol()+Period()) && GlobalVariableGet("SignalType_4"+Symbol()+Period())!=OP_BUY)
   	{
      	//if (SoundON) Alert(Symbol());
      	tmp = TimeCurrent() + (Period()-MathMod(Minute(),Period()))*60;
      	GlobalVariableSet("AlertTime_4"+Symbol()+Period(),tmp);
      	GlobalVariableSet("SignalType_4"+Symbol()+Period(),OP_BUY);
   	}
   
   	if (flagval8==1 && TimeCurrent() > GlobalVariableGet("AlertTime_4"+Symbol()+Period()) && GlobalVariableGet("SignalType_4"+Symbol()+Period())!=OP_SELL) 
   	{
      	//if (SoundON) Alert(Symbol());
      	tmp = TimeCurrent() + (Period()-MathMod(Minute(),Period()))*60;
      	GlobalVariableSet("AlertTime_4"+Symbol()+Period(),tmp);
      	GlobalVariableSet("SignalType_4"+Symbol()+Period(),OP_SELL);
   	}
   	
   	//datetime tiempoFinal = TimeCurrent()-tiempoInicio;
   	//Print(Symbol() + " " + TFToStr(Period()) + ": Tiempo de ejcucion: " + tiempoFinal);
   	return(0);
}

double conversion(string symbol)
{
	if(symbol=="" || symbol == Symbol())
	{
		if(Point==0.00001) return(0.0001);
		else if(Point==0.001) return(0.01);
		else return(Point);
	}
	else
	{
		RefreshRates();
		double tPoint = MarketInfo(symbol,MODE_POINT);
		if(tPoint==0.00001) return(0.0001);
		else if(tPoint==0.001) return(0.01);
		else return(tPoint);
	}
}

//+------------------------------------------------------------------+
//| devuelve "0" si detecta un GAP de subida, 1 si detecta un		 | 	
//| GAP de bajada. GapSize en pips               					 |
//+------------------------------------------------------------------+
int gapDetector(int n,string par,double GapSize,int timeFrame,int shift)
{
	for(int i=0; i<=n; i++)
	{
		double closeAnt= iClose(par,timeFrame,shift+i+1);
		double openAct = iOpen(par,timeFrame,shift+i);
		double gapDown = 0, gapUp = 0;
		int gapDetected = -1;
		
		if(closeAnt<openAct)
		{
			gapDown=(openAct-closeAnt)/conversion(par);
			if(gapDown>GapSize) gapDetected=0;
		}
		if(closeAnt>openAct)
		{
			gapUp=(closeAnt-openAct)/conversion(par);
			if(gapUp>GapSize) gapDetected=1;
		}
		if(gapDetected==0 || gapDetected==1) break;
	}
	return(gapDetected);
}

//Te dice el valor del punto medio de la vela
double puntoMedio(int shift)
{
	int timeFrame = Period(); string par = Symbol();
	double O = iOpen(par, timeFrame, shift);
	double C = iClose(par, timeFrame, shift);
	
	double mediaCuerpo = (C - O)/2;  //Tamao del cuerpo entre 2
	double midPoint = mediaCuerpo+O;
	
	return(midPoint);
}

//Detecta los tipos de vela: spike de subida, spike de bajada, long legged doji (LLD)
//							Volumen ultra alto en una barra alcista, sin embargo la siguiente barra cierra por debajo (debilidad)
bool detectorSpikes(string tipoSpike, int shift)
{	//La variable spike leido sera la vela[shift+1] o la vela [shift+2]
	//iHigh(string symbol, int timeframe, int shift)
	
	int timeFrame = Period(); string par = Symbol();
		
	double H = iHigh(par, timeFrame, shift);
	double L = iLow(par, timeFrame, shift);
	double O = iOpen(par, timeFrame, shift);
	double C = iClose(par, timeFrame, shift);

	double velaTotal = H-L;
	if (velaTotal<=0) return(false);
	double velaTotalPips = velaTotal/conversion(par);

	double velaCuerpo = MathAbs(O-C);
	//if (velaCuerpo<=0) return(false);
	double velaCuerpoPips = velaCuerpo/conversion(par);
	double porcentajeCuerpo = velaCuerpoPips/velaTotalPips;

	bool velaAlcista = false, velaBajista = false, doji = false;
	if(C>O) velaAlcista = true;
	else if (C<O) velaBajista = true;
	else doji = true;
	
	double spikeUpVelaAlcista   = H-C;
	double spikeUpVelaBajista   = H-O;
	double spikeDownVelaAlcista = O-L;
	double spikeDownVelaBajista = C-L;

	double spikeMayor, spikeMayorPips, Tercio=0;
	double porcentajeSpike, sumaP, porcentajeSpikeContrario;
	string msgTamano, msgPorcentaje;
	bool spikeDetectado = false, abrirDirecto = false;

	if(tipoSpike == "LS_UP")//Solo miramos los spikes inferiores --> Spike de subida
	{
		if(velaAlcista)
			{spikeMayor = spikeDownVelaAlcista;}
		else if(velaBajista)
			{spikeMayor = spikeDownVelaBajista;}
		else //estaremos en un doji
			{spikeMayor = spikeDownVelaBajista;}	
			
		spikeMayorPips = spikeMayor/conversion(par);
		porcentajeSpike = spikeMayorPips/velaTotalPips;
		sumaP = porcentajeSpike+porcentajeCuerpo;
		porcentajeSpikeContrario = 1-sumaP;
		
		double lowest3bars = Low[iLowest(NULL,0,MODE_LOW,4,shift)];
		bool spikeLowestLow = false;
		if(lowest3bars == iLow(Symbol(),Period(),shift)) spikeLowestLow = true;
	
		if(spikeMayor > 0)
		{
			//Caso 1 vela Alcista
			if(velaAlcista && ( (C-O)>(H-C) ) && ( (O-L)>(H-O) ) && LS_LongSpikeVSspikesOK(4, "Inf", spikeMayorPips, shift-1)
				&& LS_LongSpikeVStamOK(4, spikeMayorPips, shift-1) && spikeLowestLow)  return(true);
			
			//Caso 2 vela Bajista
			if(velaBajista && ( (O-C)>(H-O) ) && ( (C-L)>(H-C) ) && LS_LongSpikeVSspikesOK(4, "Inf", spikeMayorPips, shift-1)
				&& LS_LongSpikeVStamOK(4, spikeMayorPips, shift-1) && spikeLowestLow)  return(true);
				
			//Caso 3 vela Doji
			Tercio = H - ((H-L)/3);
			if(doji && ( (C-L)>(H-C) ) && ( C>Tercio ) && LS_LongSpikeVSspikesOK(4, "Inf", spikeMayorPips, shift-1)
				&& LS_LongSpikeVStamOK(4, spikeMayorPips, shift-1) && spikeLowestLow && porcentajeSpikeContrario >= 0)  return(true);
				
			return(false);
		
		}
		else return(false);
			
	}
	
	else if(tipoSpike == "LS_DOWN") //Solo miramos los spikes de arriba
	{
		if(velaAlcista)
			{spikeMayor = spikeUpVelaAlcista;}
			
		else if(velaBajista)
			{spikeMayor = spikeUpVelaBajista;}
			
		else //estaremos en un doji
			{spikeMayor = spikeUpVelaBajista;}
			
		spikeMayorPips = spikeMayor/conversion(par);
		porcentajeSpike = spikeMayorPips/velaTotalPips;
		sumaP = porcentajeSpike+porcentajeCuerpo;
		porcentajeSpikeContrario = 1-sumaP;
		
		double highest3bars = High[iHighest(NULL,0,MODE_HIGH,4,shift)];
		bool spikeHighestHigh = false;
		if(highest3bars == iHigh(Symbol(),Period(),shift)) spikeHighestHigh = true;
		
		if(spikeMayor > 0)
		{
			//Caso 1 vela Alcista
			if(velaAlcista && ( (C-O)>(O-L) ) && ( (H-C)>(C-L) ) && LS_LongSpikeVSspikesOK(4, "Sup", spikeMayorPips, shift-1)
				&& LS_LongSpikeVStamOK(4, spikeMayorPips, shift-1) && spikeHighestHigh)  return(true);
			
			//Caso 2 vela Bajista
			if(velaBajista && ( (O-C)>(C-L) ) && ( (H-O)>(O-L) ) && LS_LongSpikeVSspikesOK(4, "Sup", spikeMayorPips, shift-1)
				&& LS_LongSpikeVStamOK(4, spikeMayorPips, shift-1) && spikeHighestHigh)  return(true);
				
			//Caso 3 vela Doji
			Tercio = L + ((H-L)/3);
			if(doji && ( (H-C)>(C-L) ) && ( C<Tercio ) && LS_LongSpikeVSspikesOK(4, "Sup", spikeMayorPips, shift-1)
				&& LS_LongSpikeVStamOK(4, spikeMayorPips, shift-1) && spikeHighestHigh && porcentajeSpikeContrario >= 0)  return(true);
				
			return(false);
		
		}
		else return(false);
	}
	else return(false);
}

double tamanoSpikes(string tipoSpike, int shift)
{	//La variable spike leido sera la vela[shift+1] o la vela [shift+2]
	//iHigh(string symbol, int timeframe, int shift)
	
	int timeFrame = Period(); string par = Symbol();
	
		
	double H = iHigh(par, timeFrame, shift);
	double L = iLow(par, timeFrame, shift);
	double O = iOpen(par, timeFrame, shift);
	double C = iClose(par, timeFrame, shift);

	double velaTotal = H-L;
	if (velaTotal<=0) return(false);
	double velaTotalPips = velaTotal/conversion(par);

	double velaCuerpo = MathAbs(O-C);
	//if (velaCuerpo<=0) return(false);
	double velaCuerpoPips = velaCuerpo/conversion(par);
	double porcentajeCuerpo = velaCuerpoPips/velaTotalPips;

	bool velaAlcista = false, velaBajista = false, doji = false;
	if(C>O) velaAlcista = true;
	else if (C<O) velaBajista = true;
	else doji = true;
	
	//if(shift == iBarShift(par,timeFrame, D'2014.05.21 03:30'))
	//	Print("Fecha: " + TimeToStr(D'2014.05.21 03:30') + ", porcentajeCuerpo: " + porcentajeCuerpo + ", LongShadow_Bars_And_Volume: " + LongShadow_Bars_And_Volume(4, shift-1) + ", tipoSpike: " + tipoSpike + ", velaAlcista: " + velaAlcista + ", velaBajista: " + velaBajista);

	double spikeUpVelaAlcista   = H-C;
	double spikeUpVelaBajista   = H-O;
	double spikeDownVelaAlcista = O-L;
	double spikeDownVelaBajista = C-L;
	
	double spikeUpVelaAlcistaPips   = spikeUpVelaAlcista/conversion(par);
	double spikeUpVelaBajistaPips   = spikeUpVelaBajista/conversion(par);
	double spikeDownVelaAlcistaPips = spikeDownVelaAlcista/conversion(par);
	double spikeDownVelaBajistaPips = spikeDownVelaBajista/conversion(par);
	
	if(tipoSpike == "Inf") //Solo miramos los spikes inferiores
	{
		if(velaAlcista || doji) return(spikeDownVelaAlcistaPips);
		if(velaBajista) return(spikeDownVelaBajistaPips);
	}
	if(tipoSpike == "Sup") //Solo miramos los spikes superiores
	{
		if(velaAlcista || doji) return(spikeUpVelaAlcistaPips);
		if(velaBajista) return(spikeUpVelaBajistaPips);
	}
	
	return(0);
}

//Devuelve true si el cuerpo de la vela anterior es mayor que las 3 velas anteriores a esa vela
bool B_Bars(bool modeHG, int numeroCheckVelas, int shift) //valor standard numeroCheckVelas = 5, shift = velaActual(sin cerrar)
{//iOpen(	string symbol, int timeframe, int shift) 
	int timeFrame = Period(); string par = Symbol();
   	double precioOpen[], precioClose[], tamanoVela[];
	double maxOpenAct = 0, maxOpen = 0, maxCloseAct = 0, maxClose = 10000;
	bool todoOK = false, tamanoOK = false;
	ArrayResize(precioOpen,(numeroCheckVelas+1));ArrayResize(precioClose,(numeroCheckVelas+1));ArrayResize(tamanoVela,(numeroCheckVelas+1));

	for(int i = 1; i <= numeroCheckVelas; i++)
	{
		//tenemos que analizar todas las velas menos 
		// i == -1 --> analizamos la vela shift == 1, i == 0 --> shift = 2...
		precioOpen[i] = iOpen(par, timeFrame, shift+i);
		precioClose[i]  = iClose(par, timeFrame, shift+i);
		tamanoVela[i] = MathAbs(precioOpen[i] - precioClose[i])/conversion(par);
		
		//if(shift == vela) Print("Fecha Shift: " + TimeToStr(iTime(par,timeFrame,(shift+i))) + ", tamanoVela["+(i)+"]: " + tamanoVela[i]);   
		
		if(i == numeroCheckVelas)
		{	
			for(int j = 1; j <= numeroCheckVelas; j++)
			{
				if(j>2) //Comprobamos tamaos
				{
					if( tamanoVela[2] <= tamanoVela[j]) {tamanoOK = false; break;}
					if( j == numeroCheckVelas && tamanoVela[2] > tamanoVela[j]) tamanoOK = true;
				}
			}
			//if(shift == vela) Print("Comprobacion Tamaos: tamanoOK = " + tamanoOK);
		}
	}
	
	if(modeHG && tamanoOK)
	{
       	//Comprobamos que la vela anterior y posterior al WRB no se solapan
       	int shiftB = (shift+2);
    	double O = iOpen(par, timeFrame, shiftB);
    	double C = iClose(par, timeFrame, shiftB);
    	bool velaAlcista = false, velaBajista = false, velaDoji = false;
    	if(C>O) velaAlcista = true;
    	else if (C<O) velaBajista = true;
    	else velaDoji = true;
    	bool bHG = false;
    	
    	if(velaAlcista)
    	{
    		double Hant  = iHigh(par, timeFrame, shiftB+1);
    		double Lpost = iLow(par, timeFrame, shiftB-1);
    		
    		if(Hant < Lpost) bHG = true; 
    	}
    	
    	if(velaBajista || velaDoji)
    	{
    		double Lant  = iLow(par, timeFrame, shiftB+1);
    		double Hpost = iHigh(par, timeFrame, shiftB-1);
    		
    		if(Lant > Hpost) bHG = true; 
    	}
    	
    	if(bHG) todoOK = true;
    }
    else {if(tamanoOK) todoOK = true;};
  	return(todoOK);	
}

//Devuelve true si el spike de la vela anterior es mayor al spike de las 3 velas anteriores a esa vela
bool LS_LongSpikeVSspikesOK(int numeroCheckVelas, string tipoSpike, double spikeMayor, int shift) //valor standard = 4
{
	int timeFrame = Period(); string par = Symbol();
   	double tamanoSpike[];
	double maxOpenAct = 0, maxOpen = 0, maxCloseAct = 0, maxClose = 10000;
	bool todoOK = false;
	ArrayResize(tamanoSpike,(numeroCheckVelas+1));
	for(int i = 2; i <= numeroCheckVelas; i++)
	{
		tamanoSpike[i] = tamanoSpikes(tipoSpike, shift+i);
		
		if(i == numeroCheckVelas)
		{	
			for(int j = 2; j <= numeroCheckVelas; j++)
			{
				if( spikeMayor <= tamanoSpike[j]) {todoOK = false; break;}
				if( j == numeroCheckVelas && spikeMayor > tamanoSpike[j]) todoOK = true;
			}
		}
   }
   //if(shift == shiftVela)Print("todoOK: " + todoOK);
   return(todoOK);	
}

//Devuelve true si el spike de la vela anterior es mayor al tamao de las 3 velas anteriores a esa vela
bool LS_LongSpikeVStamOK(int numeroCheckVelas, double spikeMayor, int shift) //valor standard = 4
{
	int timeFrame = Period(); string par = Symbol();
   	double precioOpen[], precioClose[], tamanoVela[];
	double maxOpenAct = 0, maxOpen = 0, maxCloseAct = 0, maxClose = 10000;
	bool todoOK = false;
	ArrayResize(precioOpen,(numeroCheckVelas+1));ArrayResize(precioClose,(numeroCheckVelas+1));ArrayResize(tamanoVela,(numeroCheckVelas+1));
	for(int i = 2; i <= numeroCheckVelas; i++)
	{
		precioOpen[i] = iOpen(par, timeFrame, shift+i);
		precioClose[i]  = iClose(par, timeFrame, shift+i);
		tamanoVela[i] = MathAbs(precioOpen[i] - precioClose[i])/conversion(par);
		
		if(i == numeroCheckVelas)
		{	
			for(int j = 2; j <= numeroCheckVelas; j++)
			{
				if( spikeMayor <= tamanoVela[j]) {todoOK = false; break;}
				if( j == numeroCheckVelas && spikeMayor > tamanoVela[j]) todoOK = true;
			}
		}
   }
   //if(shift == shiftVela)Print("todoOK: " + todoOK);
   return(todoOK);	
}

//+------------------------------------------------------------------+
string TFToStr(int tf)
//+------------------------------------------------------------------+
// Converts a MT4-numeric timeframe to its descriptor string
// Usage:   string s=TFToStr(15) returns s="M15"
{
  switch (tf)  {
    case     1 :  return("M1");
    case     5 :  return("M5");
    case    15 :  return("M15");
    case    30 :  return("M30");
    case    60 :  return("H1");
    case   240 :  return("H4");
    case  1440 :  return("D1");
    case 10080 :  return("W1");
    case 43200 :  return("MN");
  }  
  return("");
}  
